Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp	(revision 73571)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic2.cpp	(revision 73573)
@@ -42,5 +42,5 @@
 
 /* COM includes: */
-# include "CCloudUserProfiles.h"
+# include "CCloudProvider.h"
 
 #endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
@@ -71,7 +71,7 @@
     /* Init Cloud User-profile Manager: */
     CVirtualBox comVBox = vboxGlobal().virtualBox();
-    m_comCloudUserProfileManager = comVBox.CreateCloudUserProfileManager();
-    AssertMsg(comVBox.isOk() && m_comCloudUserProfileManager.isNotNull(),
-              ("Unable to acquire Cloud User-profile Manager"));
+    m_comCloudProviderManager = comVBox.CreateCloudProviderManager();
+    AssertMsg(comVBox.isOk() && m_comCloudProviderManager.isNotNull(),
+              ("Unable to acquire Cloud Provider Manager"));
 }
 
@@ -118,29 +118,30 @@
 
     /* Acquire provider ID list: */
-    QVector<KCloudProviderId> providerIds = m_comCloudUserProfileManager.GetSupportedProviders();
+//  QVector<KCloudProviderId> providerIds = m_comCloudProviderManager.GetSupportedProviders();
+    QVector<QString> providerIds = m_comCloudProviderManager.GetSupportedProviders();
     /* Make sure at least one provider is supported: */
     AssertReturnVoid(!providerIds.isEmpty());
 
     /* Iterate through provider types: */
-    foreach (KCloudProviderId enmType, providerIds)
-    {
-        /* Acquire Cloud User-profile List: */
-        CCloudUserProfiles comProfiles = m_comCloudUserProfileManager.GetProfilesByProvider(enmType);
-        /* Skip if we have nothing to populate (file missing?): */
-        if (comProfiles.isNull())
-            continue;
-
-        /* Iterate through profile names: */
-        foreach (const QString &strProfileName, comProfiles.GetStoredProfilesNames())
-        {
-            m_pAccountComboBox->addItem(QString());
-            m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, (int)enmType, ProviderID);
-            m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, strProfileName, ProfileName);
-        }
-    }
-
-    /* Set default: */
-    if (m_pAccountComboBox->count() != 0)
-        setProvider(KCloudProviderId_OCI);
+//  foreach (KCloudProviderId enmType, providerIds)
+//  {
+//      /* Acquire Cloud User-profile List: */
+//      CCloudUserProfiles comProfiles = m_comCloudProviderManager.GetProfilesByProvider(enmType);
+//      /* Skip if we have nothing to populate (file missing?): */
+//      if (comProfiles.isNull())
+//          continue;
+//
+//      /* Iterate through profile names: */
+//      foreach (const QString &strProfileName, comProfiles.GetStoredProfilesNames())
+//      {
+//          m_pAccountComboBox->addItem(QString());
+//          m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, (int)enmType, ProviderID);
+//          m_pAccountComboBox->setItemData(m_pAccountComboBox->count() - 1, strProfileName, ProfileName);
+//      }
+//  }
+//
+//  /* Set default: */
+//  if (m_pAccountComboBox->count() != 0)
+//      setProvider(KCloudProviderId_OCI);
 }
 
@@ -148,7 +149,7 @@
 {
     /* Acquire Cloud User-profile List: */
-    m_comCloudUserProfiles = m_comCloudUserProfileManager.GetProfilesByProvider(provider());
+    m_comCloudProvider = m_comCloudProviderManager.GetProfilesByProvider(provider());
     /* Return if we have nothing to populate (file missing?): */
-    if (m_comCloudUserProfiles.isNull())
+    if (m_comCloudProvider.isNull())
         return;
 
@@ -159,5 +160,5 @@
     QVector<QString> keys;
     QVector<QString> values;
-    values = m_comCloudUserProfiles.GetProfileProperties(profile(), keys);
+    values = m_comCloudProvider.GetProfileProperties(profile(), keys);
 
     /* Configure table: */
@@ -177,5 +178,5 @@
 
             /* Use non-translated description as tool-tip: */
-            const QString strToolTip = m_comCloudUserProfiles.GetPropertyDescription(keys.at(i));
+            const QString strToolTip = m_comCloudProvider.GetPropertyDescription(keys.at(i));
             pItemK->setData(Qt::UserRole, strToolTip);
 
@@ -422,8 +423,15 @@
 }
 
-KCloudProviderId UIWizardExportAppPage2::provider() const
-{
-    const int iIndex = m_pAccountComboBox->currentIndex();
-    return (KCloudProviderId)m_pAccountComboBox->itemData(iIndex, ProviderID).toInt();
+//KCloudProviderId UIWizardExportAppPage2::provider() const
+//{
+//  const int iIndex = m_pAccountComboBox->currentIndex();
+//  return (KCloudProviderId)m_pAccountComboBox->itemData(iIndex, ProviderID).toInt();
+//}
+
+QString UIWizardExportAppPage2::provider() const
+{
+    return "OCI";
+//const int iIndex = m_pAccountComboBox->currentIndex();
+//return (KCloudProviderId)m_pAccountComboBox->itemData(iIndex, ProviderID).toInt();
 }
 
@@ -434,7 +442,7 @@
 }
 
-CCloudUserProfiles UIWizardExportAppPage2::profiles() const
-{
-    return m_comCloudUserProfiles;
+CCloudProvider UIWizardExportAppPage2::profiles() const
+{
+    return m_comCloudProvider;
 }
 